diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index 8eb71cb96..1009b1b4d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.hud.component;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
@@ -8,7 +7,6 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemBucketIceCream;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
new file mode 100644
index 000000000..049f2df6f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
@@ -0,0 +1,112 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL11;
+
+import java.util.Random;
+
+public class HudComponentVehicleHealthBar
+    extends HudComponentMovable {
+    private final Random random = new Random();
+
+    public HudComponentVehicleHealthBar(String key, Layout layout) {
+        super(key, 81, 10, layout);
+    }
+
+    @Override
+    public boolean isVisible() {
+        return mc.thePlayer.vehicle instanceof Mob && mc.gameSettings.immersiveMode.drawHotbar();
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        if (mc.thePlayer.vehicle instanceof Mob mobVehicle) {
+            int x = this.getLayout().getComponentX(this, xSizeScreen);
+            int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+            // Setup rendering
+            GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+            GL11.glDisable(GL11.GL_BLEND);
+
+            boolean heartsFlash = (mobVehicle.heartsFlashTime / 3) % 2 == 1;
+            if (mobVehicle.heartsFlashTime < 10)
+            {
+                heartsFlash = false;
+            }
+            int health = mobVehicle.getHealth();
+            int prevHealth = mobVehicle.prevHealth;
+            random.setSeed(hud.updateCounter * 0x4c627L);
+
+            int hearts = MathHelper.ceil(mobVehicle.getMaxHealth()/2f);
+            for (int i = 0; i < hearts; i++) {
+                int heartOffset = 0;
+                if (heartsFlash)
+                {
+                    heartOffset = 1;
+                }
+                int xHeart = (x + 9 * 8) - i * 8;
+                int yHeart = y;
+                if (health <= 4)
+                {
+                    yHeart += random.nextInt(2);
+                }
+
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container_blinking"));
+                if (heartsFlash)
+                {
+                    if (i * 2 + 1 < prevHealth)
+                    {
+                        // Half flash heart icon
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full_blinking"));
+                    }
+                    if (i * 2 + 1 == prevHealth)
+                    {
+                        // Full flash heart icon
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half_blinking"));
+                    }
+                }
+                if (i * 2 + 1 < health)
+                {
+                    // Full heart icon
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full"));
+                }
+                if (i * 2 + 1 == health)
+                {
+                    // Half heart icon
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half"));
+                }
+            }
+        }
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+
+        // Setup rendering
+        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        GL11.glDisable(GL11.GL_BLEND);
+
+        int health = 11;
+        for (int i = 0; i < 10; i++) {
+            int xHeart = x + i * 8;
+            gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container"));
+            if (i * 2 + 1 < health)
+            {
+                // Full heart icon
+                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full"));
+            }
+            if (i * 2 + 1 == health)
+            {
+                // Half heart icon
+                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half"));
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 8dc127e0c..50cd463ff 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -61,7 +61,8 @@ public class HudComponents {
     public static final HudComponent HOTBAR = register(new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER)));
     public static final HudComponent CROSSHAIR = register(new HudComponentCrosshair("crosshair", new LayoutAbsolute(0.5f, 0.5f, ComponentAnchor.CENTER)));
     public static final HudComponent HEALTH_BAR = register(new HudComponentHealthBar("health_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final HudComponent ARMOR_BAR = register(new HudComponentArmorBar("armor_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
+//    public static final HudComponent ARMOR_BAR = register(new HudComponentArmorBar("armor_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final HudComponent VEHICLE_BAR = register(new HudComponentVehicleHealthBar("vehicle_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
     public static final HudComponent OXYGEN_BAR = register(new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index 3b0599380..085adda56 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.SliderElement;
 import net.minecraft.client.option.OptionFloat;
 import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.Nullable;
 
 public class FloatOptionComponent
@@ -11,32 +12,47 @@ public class FloatOptionComponent
 {
     protected final OptionFloat option;
     protected final SliderElement slider;
+    protected final float minValue;
+    protected final float maxValue;
 
     public FloatOptionComponent(OptionFloat option)
     {
-        this(option, null);
+        this(option, 0, 1, null);
+    }
+
+    public FloatOptionComponent(OptionFloat option, float minValue, float maxValue)
+    {
+        this(option, minValue, maxValue, null);
     }
 
     public FloatOptionComponent(OptionFloat option, @Nullable String tooltipTranslationKey)
+    {
+        this(option, 0, 1, tooltipTranslationKey);
+    }
+
+    public FloatOptionComponent(OptionFloat option, float minValue, float maxValue, @Nullable String tooltipTranslationKey)
     {
         super("options." + option.name, tooltipTranslationKey);
 
         this.option = option;
         this.option.addCallback(__ -> onChanged());
         this.slider = new SliderElement(0, 0, 0, 150, 20, this.option.getDisplayStringValue(), this.option.value);
+
+        this.minValue = minValue;
+        this.maxValue = maxValue;
     }
 
     @Override
     protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
         this.slider.mouseClicked(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
-        this.option.set((float) this.slider.sliderValue);
+        this.option.set((float) MathHelper.lerp(minValue, maxValue, this.slider.sliderValue));
         onChanged();
         this.option.onUpdate();
     }
 
     @Override
     protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
-        this.option.set((float) this.slider.sliderValue);
+        this.option.set((float) MathHelper.lerp(minValue, maxValue, this.slider.sliderValue));
         this.slider.mouseDragged(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
         onChanged();
         this.option.onUpdate();
@@ -45,7 +61,7 @@ public class FloatOptionComponent
     @Override
     protected void buttonReleased(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
         this.slider.mouseReleased(this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
-        this.option.set((float) this.slider.sliderValue);
+        this.option.set((float) MathHelper.lerp(minValue, maxValue, this.slider.sliderValue));
         onChanged();
         this.option.onUpdate();
     }
@@ -70,14 +86,14 @@ public class FloatOptionComponent
     @Override
     public void resetValue() {
         option.set(option.getDefaultValue());
-        slider.sliderValue = option.value;
+        slider.sliderValue = MathHelper.unlerp(minValue, maxValue, option.value);
         onChanged();
         option.onUpdate();
     }
 
     @Override
     public void init(Minecraft mc){
-        slider.sliderValue = option.value;
+        slider.sliderValue = MathHelper.unlerp(minValue, maxValue, option.value);
         onChanged();
     }
 
@@ -87,6 +103,7 @@ public class FloatOptionComponent
 
     @Override
     public boolean isDefault() {
-        return option.value.equals(option.getDefaultValue());
+        float diff = Math.abs(option.value - option.getDefaultValue());
+        return diff < 0.0001f;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 5ada75d6f..1e020bf29 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -175,7 +175,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.vignette))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.items3D))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.clouds))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.cloudHeight))
+                .withComponent(new FloatOptionComponent(mc.gameSettings.cloudHeight, -0.5f, 1f))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.aurora))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.slimeParticles))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.blockOutlineWidth))
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 67d096a7a..3b118fc33 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -10,6 +10,7 @@ import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
@@ -245,7 +246,7 @@ public class WorldRenderer
         }
     }
 
-    private void setupViewBobbing(float partialTick)
+    private void setupViewBobbing(float partialTick, boolean isHand)
     {
         if (mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).mob instanceof Player)
         {
@@ -253,6 +254,11 @@ public class WorldRenderer
             float walkDist = -MathHelper.lerp(player.walkDistO, player.walkDist, partialTick);
             float cameraVel = MathHelper.lerp(player.cameraVelocityOld, player.cameraVelocity, partialTick);
             float cameraPitch = MathHelper.lerp(player.prevCameraPitch, player.cameraPitch, partialTick);
+            if (isHand && player.vehicle instanceof MobPig) {
+                cameraVel /= 4;
+//                cameraPitch /= 4;
+                walkDist /= 2;
+            }
             if (player.isSkating) {
                 walkDist *= 0.25f;
                 cameraPitch *= 0.25f;
@@ -343,7 +349,7 @@ public class WorldRenderer
         hurtCameraEffect(partialTicks);
         if(this.mc.gameSettings.viewBobbing.value && !(this.mc.currentScreen instanceof ScreenPhotoMode))
         {
-            setupViewBobbing(partialTicks);
+            setupViewBobbing(partialTicks, false);
         }
         final float portalIntensity = this.mc.gameSettings.screenMotionEffects.value ? MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTicks) : 0f;
         if(portalIntensity > 0.0F)
@@ -379,7 +385,7 @@ public class WorldRenderer
         hurtCameraEffect(partialTick);
         if(mc.gameSettings.viewBobbing.value)
         {
-            setupViewBobbing(partialTick);
+            setupViewBobbing(partialTick, true);
         }
         if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof ScreenPhotoMode) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).mob.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
         {
@@ -399,7 +405,7 @@ public class WorldRenderer
         }
         if(mc.gameSettings.viewBobbing.value)
         {
-            setupViewBobbing(partialTick);
+            setupViewBobbing(partialTick, false);
         }
     }
     private float getZoomedFOV(float currentFov, float partialTick){
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 1b491f4a0..3f3239bd4 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -166,7 +166,7 @@ public class WorldClient extends World {
     }
 
     @Override
-    public int getLightmapCoord(int skylight, int blocklight) {
-        return LightmapHelper.getLightmapCoord(skylight, blocklight);
+    public int getLightmapCoord(int skyLight, int blockLight) {
+        return LightmapHelper.getLightmapCoord(skyLight, blockLight);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 982700b31..82b9e4d56 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -12,6 +12,8 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.client.world.save.SaveHandlerClientMP;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.HashSet;
 import java.util.LinkedList;
@@ -106,8 +108,8 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-	public void scheduleBlockUpdate(int x, int y, int z, int id, long delay)
-    {
+    public void scheduleBlockUpdate(final @NotNull TilePos tilePos, final int id, final long delay, final boolean loaded) {
+        // Do nothing
     }
 
     @Override
@@ -201,46 +203,37 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-	public boolean setBlockMetadata(int x, int y, int z, int meta)
-    {
-        int blockID = getBlockId(x, y, z);
-        int currentMeta = getBlockMetadata(x, y, z);
-        if(super.setBlockMetadata(x, y, z, meta))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockID, currentMeta));
+    public boolean setBlockData(final @NotNull TilePos tilePos, final int data) {
+        final int id = this.getBlockId(tilePos);
+        final int currentData = this.getBlockData(tilePos);
+        if (super.setBlockData(tilePos, data)) {
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x, tilePos.y, tilePos.z, id, currentData));
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
 
     @Override
-	public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
-    {
-        int blockId = getBlockId(x, y, z);
-        int blockMeta = getBlockMetadata(x, y, z);
-        if(super.setBlockAndMetadata(x, y, z, id, meta))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, blockMeta));
+    public boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data) {
+        final int currentId = this.getBlockId(tilePos);
+        final int currentData = this.getBlockData(tilePos);
+        if (super.setBlockIdData(tilePos, id, data)) {
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x, tilePos.y, tilePos.z, currentId, currentData));
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
 
     @Override
-	public boolean setBlock(int x, int y, int z, int id)
-    {
-        int blockId = getBlockId(x, y, z);
-        int meta = getBlockMetadata(x, y, z);
-        if(super.setBlock(x, y, z, id))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, meta));
+    public boolean setBlockId(final @NotNull TilePos tilePos, final int id) {
+        final int currentId = this.getBlockId(tilePos);
+        final int data = this.getBlockData(tilePos);
+        if (super.setBlockId(tilePos, id)) {
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x, tilePos.y, tilePos.z, currentId, data));
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
index 46cfe5563..840a5abe3 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
@@ -224,7 +224,7 @@ public class ChunkProviderDynamic implements IChunkProvider
         }
         catch(IOException ioexception)
         {
-            LOGGER.error("Failed to save chunk at {}, {}!", chunk.xPosition, chunk.zPosition, ioexception);
+            LOGGER.error("Failed to save chunk at {}, {}!", chunk.pos.x, chunk.pos.z, ioexception);
         }
     }
 
@@ -252,7 +252,7 @@ public class ChunkProviderDynamic implements IChunkProvider
         int dropped = 0;
         for (Chunk chunk : chunkMap.values()) {
             if(dropped >= maxUnloadPerTick) break;
-            isChunkLoaded(chunk.xPosition,chunk.zPosition); //droppedChunksSet gets updated as side-effect
+            isChunkLoaded(chunk.pos.x, chunk.pos.z); //droppedChunksSet gets updated as side-effect
         }
         if(!droppedChunksSet.isEmpty()){
             int unloaded = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index 8f93b4bd1..6d23651e8 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -219,7 +219,7 @@ public class ChunkProviderStatic
         }
         catch(IOException e)
         {
-            LOGGER.error("Error saving chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, e);
+            LOGGER.error("Error saving chunk at X:{}, Z:{}", chunk.pos.x, chunk.pos.x, e);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 5275da452..990fe0d91 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -26,8 +26,10 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -282,28 +284,14 @@ public final class Block<T extends BlockLogic>
         return new ItemStack(this);
     }
 
-    public static boolean isBuried (World world, int x, int y, int z)
-    {
-        boolean buried = true;
-        if(Blocks.lightBlock[world.getBlockId(x + 1, y, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x - 1, y, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y, z + 1)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y, z - 1)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y + 1, z)] <= 2)
-            buried = false;
-        if(Blocks.lightBlock[world.getBlockId(x, y - 1, z)] <= 2)
-            buried = false;
-        return buried;
-    }
-
-    public static boolean getIsLitInteriorSurface (World world, int x, int y, int z)
-    {
-        int l = world.getBlockId(x, y, z);
-        return l != 0 && Blocks.blocksList[l] != null && Blocks.blocksList[l].isLitInteriorSurface;
+    public static boolean getIsLitInteriorSurface(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = source.getBlock(tilePos);
+        return block != null && block.isLitInteriorSurface;
+    }
+
+    @Deprecated
+    public static boolean getIsLitInteriorSurface(final @NotNull WorldSource source, final int x, final int y, final int z) {
+        return getIsLitInteriorSurface(source, new TilePos(x, y, z));
     }
 
     @SafeVarargs
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 067fb5261..de389dd89 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -590,7 +590,7 @@ public abstract class Entity
 				bb.move(0.0D, yd, 0.0D);
 			}
 			cubes = world.getCubes(this, bb);
-			if(oldX * oldX + oldZ * oldZ >= xd * xd + zd * zd || cubes.size() > 0) {
+			if(oldX * oldX + oldZ * oldZ >= xd * xd + zd * zd || !cubes.isEmpty()) {
 				xd = oldX;
 				yd = oldY;
 				zd = oldZ;
@@ -834,9 +834,9 @@ public abstract class Entity
         return world.isMaterialInBB(bb/*.expand(-0.1D, -0.4D, -0.1D)*/, Material.lava);
     }
 
-    public void moveRelative(float f, float f1, float f2)
+    public void moveRelative(float strafe, float forward, float speed)
     {
-        float f3 = MathHelper.sqrt_float(f * f + f1 * f1);
+        float f3 = MathHelper.sqrt_float(strafe * strafe + forward * forward);
         if(f3 < 0.01F)
         {
             return;
@@ -845,14 +845,14 @@ public abstract class Entity
         {
             f3 = 1.0F;
         }
-        f3 = f2 / f3;
-        f *= f3;
-        f1 *= f3;
+        f3 = speed / f3;
+        strafe *= f3;
+        forward *= f3;
 
         float sinYaw = MathHelper.sin((yRot * MathHelper.PI) / 180F);
         float cosYaw = MathHelper.cos((yRot * MathHelper.PI) / 180F);
-        xd += f * cosYaw - f1 * sinYaw ;
-        zd += f1 * cosYaw + f * sinYaw;
+        xd += strafe * cosYaw - forward * sinYaw ;
+        zd += forward * cosYaw + strafe * sinYaw;
     }
 
     public float getBrightness(float partialTick)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index eebfdd8fe..5942b6401 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -211,6 +211,8 @@ public abstract class Mob extends Entity
         return !removed;
     }
 
+    public boolean isJumping() { return isJumping; }
+
     @Override
 	public float getHeadHeight()
     {
